--
-- Mod: Field Data
--
-- Author: xDeekay
-- email: domkopp29@gmail.com
-- @Date: 07.01.2019 (0.0.0.1 Beta basic data (size, keyinputs, seed, price))
-- @Date: 21.01.2019 (0.0.2 Beta bugfix wheat, fields not bought show, lime, fertilizer calculation)
-- @Version: 0.0.2 Beta
-- Copyright (C) xDeekay, All Rights Reserved.

fieldData = {};

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");

fieldData.version = getXMLString(modDesc, "modDesc.version");
fieldData.modDirectory = g_currentModDirectory;

inputsActive = false
showFieldData = false
fruitIndex = 1 -- number of index for fruits above the field (drawing Data)
addModEventListener(fieldData);

function fieldData:loadMap()

print("############################################################");
print("--- Field Data v.:" .. self.version .. ", by xDeekay.");
print("############################################################");

end

function fieldData:keyEvent(unicode, sym, modifier, isDown)

end;

function fieldData:mouseEvent(posX, posY, isDown, isUp, button)
end;

function fieldData:deleteMap()
end;

function fieldData:update(dt)
    
    if g_currentMission:getIsClient() then
        if g_gui.currentGui == nil and g_currentMission.controlledVehicle == nil then

        if not inputsActive then
                local _1, eventShowFieldData = g_currentMission.inputManager:registerActionEvent(InputAction.FIELD_DATA, fieldData, fieldData.ShowFieldData, false, true, false, true); --, false, true, false, true); 
                    if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowFieldData] ~= nil then 
                        g_inputBinding.events[eventShowFieldData].displayIsVisible = false 
                    end 
                     local _2, eventIncreaseFruitIndex = g_currentMission.inputManager:registerActionEvent(InputAction.FIELD_DATA_INCREASE_INDEX, fieldData, fieldData.IncreaseFruitIndex, false, true, false, true); --, false, true, false, true); 
                    if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventIncreaseFruitIndex] ~= nil then 
                        g_inputBinding.events[eventIncreaseFruitIndex].displayIsVisible = false 
                    end 
            else
                inputsActive = false
            end
        end
    end
end

function fieldData:IncreaseFruitIndex()
     
    if fruitIndex ~= nil then
        print("fruitindex: " .. tostring(fruitIndex)) 
        if fruitIndex == 15 then  -- 16 = unkraut brings nil fault
          fruitIndex = 0 -- start at wheat fruit
        end
        
        fruitIndex = fruitIndex + 1
    end
end 

function fieldData:ShowFieldData()
    showFieldData =not showFieldData
end

function fieldData:getPlayerPosition()
     if g_currentMission.player ~= nil then 
      local player_pos_x,player_pos_y,player_pos_z = g_currentMission.player:getPositionData()
        return player_pos_x,player_pos_y,player_pos_z
        else 
            return 0,0,0;
        end
end

function fieldData:draw()
    
    if showFieldData == true then 
    
    setTextBold(false);
    setTextColor(1,1,1,1); 
    setTextAlignment(RenderText.ALIGN_CENTER); 
    linePadding = 0.003;
    fontSize = 0.013;
    paddingBetweenLines = fontSize + 0.004;
    
    local playerIsOwnerOfField = false
    local fieldInfoText = ""
   -- local fieldAreaInHa = 0.0
    local fieldPrice = 0.0
    local distanceFromPlayerToField = 0.0
    local maxDistanceFromPlayerToField = 150.0 -- meters away from player 
    
    local player_pos_x,player_pos_y,player_pos_z = fieldData:getPlayerPosition()
    
    local x1, y1, z1 = getWorldTranslation(getCamera())
    
    if g_fieldManager.fields ~= nil then 
  
    for k,field in pairs(g_fieldManager.fields) do
        
        local farmland = field.farmland
        local field_pos_x = field.posX
        local field_pos_z = field.posZ
        local field_Id = field.fieldId
        local field_hectar = field.fieldArea
        local farmland_hectar = farmland.areaInHa
        local fieldPartitions = 0 
        local field_fruitType = ""
        local field_fruitTypeName = ""
        local farmland_price = farmland.price
        local fruitSeedNeededForField = 0.0
        
        distanceFromPlayerToField = math.sqrt(math.pow((player_pos_x - field_pos_x),2) + math.pow((player_pos_z - field_pos_z),2))
        if distanceFromPlayerToField < maxDistanceFromPlayerToField then

        local x = field_pos_x
        local y = 100 -- meters above the field
        local z = field_pos_z
        local dist1 = x-x1
        local dist2 = y-y1
        local dist3 = z-z1
        local dist = MathUtil.vector3Length(dist1, dist2, dist3)
           if dist <= 150 then
            sx, sy, sz = project(x, y, z)
            if sz <= 1 then -- shows the text only in one direction
       
                fieldPartitions = fieldData:getTableLength(field.getFieldStatusPartitions)
           
                local field_fruitType = fruitIndex -- player must press a key to increase the number
                local field_fruitTypeName = ""
                  --  if field_fruitType ~= 16 then -- unkraut
                        field_fruitTypeName = g_fruitTypeManager.indexToFruitType[field_fruitType].fillType.title -- name of Fruit in String
                   -- else 
                    -- i fruittype not valid
                     --   field_fruitTypeName = "unknown fruit"
                  --  end
            
            
                --- seed
                local fruitSeedNeededForField = math.ceil(fieldData:calculateSeedQuantityForField(field_hectar, field_fruitType))
                local field_fruitPrice = fieldData:calculateSeedPriceForField(fruitSeedNeededForField)
                
                --- lime 
                local limeNeededForField = math.ceil(fieldData:calculateProductQuantityForField(field_hectar,"lime"))
                local field_limePrice = fieldData:calculateLimePriceForField(limeNeededForField)
                
                --- mineralFertilizer 
                local mineralFertilizerNeededForField = math.ceil(fieldData:calculateProductQuantityForField(field_hectar,"mineralFertilizer"))
                local field_mineralFertilizerPrice = fieldData:calculateMineralFertilizerPriceForField(mineralFertilizerNeededForField)
                
                --- liquidFertilizer 
                local liquidFertilizerNeededForField = math.ceil(fieldData:calculateProductQuantityForField(field_hectar,"liquidFertilizer"))
                local field_liquidFertilizerPrice = fieldData:calculateLiquidFertilizerPriceForField(liquidFertilizerNeededForField)
                
                --- herbicideLiquid
                local herbicideLiquidNeededForField = math.ceil(fieldData:calculateProductQuantityForField(field_hectar,"herbicideLiquid"))
                local field_herbicideLiquidPrice = fieldData:calculateherbicideLiquidForField(herbicideLiquidNeededForField)
                
                
                local moneyUnit = g_i18n.moneyUnit
                local currency = ""
                    if moneyUnit == 1 then 
                        currency = "€" elseif moneyUnit == 2 then 
                            currency = "$" elseif moneyUnit == 3 then 
                                currency = "£" end
                               
                        if farmland.isOwned == true then 
                            playerIsOwnerOfField = true
                            setTextBold(false)
                            setTextColor(1, 1, 1, 1) -- white 
                            renderText(sx,sy,fontSize,"Field: " .. field_Id .. " Field ha: ".. tostring(field_hectar) .. " Farmland ha: " .. tostring(farmland_hectar))
                            --setTextBold(true)
                            setTextColor(0, 1, 0, 1) -- green 
                            
                            local seed =                    "ca.: " .. tostring(fieldData:format_thousand(fruitSeedNeededForField)) .. "L " ..tostring(field_fruitTypeName) .. " / Price: " .. tostring(fieldData:format_thousand(field_fruitPrice)) .. tostring(currency)
                            local lime =                    "ca.: " .. tostring(fieldData:format_thousand(limeNeededForField)) .. "L Lime / Price: " .. tostring(fieldData:format_thousand(field_limePrice)) .. tostring(currency)
                            local mineralFertilizer =       "ca.: " .. tostring(fieldData:format_thousand(mineralFertilizerNeededForField)) .. "L MineralFertilizer / Price: " .. tostring(fieldData:format_thousand(field_mineralFertilizerPrice)) .. tostring(currency)
                            local liquidFertilizer =        "ca.: " .. tostring(fieldData:format_thousand(liquidFertilizerNeededForField)) .. "L LiquidFertilizer / Price: " .. tostring(fieldData:format_thousand(field_liquidFertilizerPrice)) .. tostring(currency)
                            local herbicide =   "ca.: " .. tostring(fieldData:format_thousand(herbicideLiquidNeededForField)) .. "L Herbicide / Price: " .. tostring(fieldData:format_thousand(field_herbicideLiquidPrice)) .. tostring(currency)
                            
                            -- seed
           
                            renderText(sx,sy-paddingBetweenLines-0.015,fontSize,seed .. "\n" .. lime.. "\n" .. mineralFertilizer.. "\n" .. liquidFertilizer.. "\n" .. herbicide)
                            
--                            -- lime
--                            renderText(sx,sy-paddingBetweenLines-0.018,fontSize,lime)
                           
--                            -- mineralFertilizer 
--                            renderText(sx,sy-paddingBetweenLines-0.021,fontSize,mineralFertilizer)
                           
--                            -- liquidFertilizer 
--                            renderText(sx,sy-paddingBetweenLines-0.024,fontSize,liquidFertilizer)
                           
--                            -- plantProtectionLiquid
--                            renderText(sx,sy-paddingBetweenLines-0.027,fontSize,plantProtectionLiquid)
                            
--                            -- sprayFactorOfField
--                            local sprayFactor = FieldUtil.getSprayFactor(field_Id)
--                            renderText(sx,sy-paddingBetweenLines-0.030,fontSize,"Sprayed: " .. tostring(sprayFactor) .. "%")
                           
                           else
                                -- farmland not owned
                            playerIsOwnerOfField = false
                            setTextBold(false)
                            setTextColor(1, 1, 1, 1) -- white 
                            renderText(sx,sy,fontSize,"Field: " .. field_Id .. "\n Field ha: ".. tostring(field_hectar) .. " Farmland ha: " .. tostring(farmland_hectar) .. "\n Price: " .. tostring(fieldData:format_thousand(farmland_price)) .. tostring(currency))
                           
--                            setTextBold(true)
--                            setTextColor(0, 1, 0, 1) -- green 
--                            renderText(sx,sy-paddingBetweenLines-0.030,fontSize,"ca.: " .. tostring(format_thousand(fruitSeedNeededForField)) .. "L " ..tostring(field_fruitTypeName) .. " needed Price: " .. tostring(format_thousand(field_fruitPrice)) .. tostring(currency)) 
                
                            end
                        end
                   end 
                end
            end
        end
    end 
end

        function fieldData:format_thousand(v)
            local s = string.format("%d", math.floor(v))
            local pos = string.len(s) % 3
            if pos == 0 then pos = 3 end
            return string.sub(s, 1, pos)
            .. string.gsub(string.sub(s, pos+1), "(...)", ".%1")
        end
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
    -- this function calculate the seed quantity for the field close to the player
    function fieldData:calculateSeedQuantityForField(fieldHectar, fruitTypeIndex)
        
        local quantity = 0; -- quantity to seed the complete field with the selected fruitType
        local field_m2 = 0.0
        local seedUsagePerSqm = 0.0
        
            if fieldHectar ~= nil and fruitTypeIndex ~= nil then 
                seedUsagePerSqm = g_fruitTypeManager.indexToFruitType[fruitTypeIndex].seedUsagePerSqm
                field_m2 = fieldHectar * 10000 -- from hectar in m2
                
                quantity = math.ceil(field_m2 * seedUsagePerSqm)
            end  
            
        return quantity
    end 
    
      -- this function calculate the fruit seed price per liter for the field close to the player
    function fieldData:calculateSeedPriceForField(seedQuantity)
        
        local seedPrice = 900; -- price in €,$ for seeding bag
        local price = 0 -- for seedQuantity
            if seedQuantity ~= nil then 
                price = math.ceil((seedPrice/1000) * seedQuantity)
            end  
        return price
    end 
    
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

-- this function calcultes the needed product quantity for the given field. 
function fieldData: calculateProductQuantityForField(fieldHectar, product)
    
        local quantity = 0; -- quantityof the product for the field 
        local field_m2 = 0.0
        local productQuantityPerSqm = 0.0
        
        if product == "lime" then
            productQuantityPerSqm = 0.60
        elseif  product == "mineralFertilizer" then
          productQuantityPerSqm = 0.03
          
           elseif  product == "liquidFertilizer" then
             productQuantityPerSqm = 0.03 
           elseif  product == "herbicideLiquid" then
             productQuantityPerSqm = 0.03   
        end
         if fieldHectar ~= nil then 
             field_m2 = fieldHectar * 10000 -- from hectar in m2
             quantity = math.ceil(field_m2 * productQuantityPerSqm)
        end 
     return quantity
end 

       -- this function calculate the LiquidFertilizer price per liter for the field close to the player
    function fieldData:calculateLiquidFertilizerPriceForField(fertilizerQuantity)
        
        local fertilizerPrice = 3200; -- price in €,$ for liquid fertilizer bag
        local price = 0 -- for fertilizerQuantity
            if fertilizerQuantity ~= nil then 
                price = math.ceil((fertilizerPrice/2000) * fertilizerQuantity) -- pallet has 2000 liter!! not 1000
            end  
        return price
    end 
    
         -- this function calculate the Mineral Fertilzer price per liter for the field close to the player
    function fieldData:calculateMineralFertilizerPriceForField(fertilizerQuantity)
        
        local fertilizerPrice = 1920; -- price in €,$ for mineral fertilizer bag
        local price = 0 -- for fertilizerQuantity
            if fertilizerQuantity ~= nil then 
                price = math.ceil((fertilizerPrice/1000) * fertilizerQuantity)
            end  
        return price
    end 
    
         -- this function calculate the Lime (Kalk) price per liter for the field close to the player
    function fieldData:calculateLimePriceForField(limeQuantity)
        
        local limePrice = 450; -- price in €,$ for lime bag
        local price = 0 -- for fertilizerQuantity
            if limeQuantity ~= nil then 
                price = math.ceil((limePrice/2000) * limeQuantity) -- bag has 2000 liter!! not 1000
            end  
        return price
    end 
    
          -- this function calculate the plantProtectionLiquid (Spritzmittel) price per liter for the field close to the player
    function fieldData:calculateherbicideLiquidForField(liquidQuantity)
        
        local liquidPrice = 2400; -- price in €,$ for pallet of liquid
        local price = 0 -- for fertilizerQuantity
            if liquidQuantity ~= nil then 
                price = math.ceil((liquidPrice/2000) * liquidQuantity) -- pallet has 2000 liter!! not 1000
            end  
        return price
    end 
    
function fieldData:getTableLength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

--function fieldData:getVehiclesData()
    
--   --   local vehicleDatabase = {}
--      local vehicleName = ""
--      local vehicleInOperation = false
--      --local posYPadding = y - paddingBetweenLines
--      local vehiclesCounter = {};

--    if g_currentMission.vehicles ~= nil then 
--        for k,vehicle in pairs(g_currentMission.vehicles) do   
--           -- if vehicle:getCurrentHelper() ~= nil then 
--                if vehicle:getIsOnField() == true then
--                    if vehicle:getFullName() ~= nil then
--                        vehicleName = vehicle:getFullName() -- string
--                      --  table.insert(vehiclesCounter, vehicleName)
--                        renderText(x,posYPadding,fontSize,"Vehicle: " ..vehicleName.. " Operating: " .. tostring(vehicleInOperation))        
--                    end
--                end
            
--         --   end 
        
--        end
--    end
--    --return vehicleDatabase
--end
